Graphics 640,480,16,2
AppTitle("Mission: Gondelbahn")
HidePointer()
Global menu_font=LoadFont("Arial",50,1)
Global status_font=LoadFont("Arial",15,1)
timer=CreateTimer(60)
Global mx,temp_mx,my,mh,scroll_x
Global fps,temp_fps,fps_millisecs=MilliSecs(),punkte,zeit
Global mast_anzahl,gondel_anzahl,station_anzahl
Global level_anzahl,level_nummer=2
Type gondel
Field x#,y#,temp_x#,temp_y#
Field mast
Field richtung
Field kaputt
Field fall
Field del
End Type
Restore mapdata
Read mast_anzahl
Dim mast(mast_anzahl,1)
For i=0 To mast_anzahl-1
Read mast(i,0),mast(i,1)
Next
Read station_anzahl
Dim station(station_anzahl,1)
For i=0 To station_anzahl-1
Read station(i,0),station(i,1)
Next
Restore leveldata
Read level_anzahl
Dim level(level_anzahl-1,3)
For i=0 To level_anzahl-1
Read level(i,0),level(i,1),level(i,2),level(i,3)
Next
.mapdata
Data 10
Data 50,390
Data 170,390
Data 280,380
Data 400,350
Data 520,300
Data 630,250
Data 700,200
Data 780,180
Data 880,170
Data 1000,170
Data 2
Data 10,350
Data 930,130
.leveldata
Data 6
Data 20,98,1,120
Data 10,196,1,90
Data 20,49,2,75
Data 10,98,2,60
Data 20,32,3,45
Data 10,64,3,30
hintergrund_=CreateImage(1,480)
SetBuffer ImageBuffer(hintergrund_)
LockBuffer ImageBuffer(hintergrund_)
For i=0 To 479
rgb=$1000000+(255*i/1000)*$10000+(255*i/1000)*$100+255
WritePixelFast(0,i,rgb)
Next
UnlockBuffer ImageBuffer(hintergrund_)
hintergrund=CreateImage(640,480)
SetBuffer ImageBuffer(hintergrund)
TileBlock hintergrund_,0,0
station_img=CreateImage(120,105)
SetBuffer ImageBuffer(station_img)
Color 255,0,0
Rect 0,15,120,20,1
Color 120,60,0
Rect 23,0,14,5,1
Rect 25,0,10,25,1
Color 200,200,200
Rect 10,35,100,70,1
Color 0,0,0
Rect 20,55,10,20,1
Rect 35,55,10,20,1
Rect 50,55,10,20,1
Rect 65,55,10,20,1
Rect 80,55,10,20,1
For i=0 To 1
Plot 0+i*117,15
Plot 1+i*117,15
Plot 2+i*117,15
Plot 0+i*119,16
Plot 0+i*119,17
Plot 0+i*119,34
Next
Global gondel_img=CreateImage(31,20)
SetBuffer ImageBuffer(gondel_img)
Color 0,0,100
Rect 0,0,31,20,1
Color 0,0,0
Rect 3,3,11,7
Rect 17,3,11,7
Oval -1,12,5,5,1
Oval 27,12,5,5,1
Plot 0,0
Plot 30,0
Plot 30,19
Plot 0,19
berg=CreateImage(1090,480)
SetBuffer ImageBuffer(berg)
Local winkel#,x#,y#
LockBuffer ImageBuffer(berg)
x=mast(0,0)
y=mast(0,1)+52
mast_number=0
Repeat
winkel=ATan2(mast(mast_number,1)+52-y,mast(mast_number,0)-x)
x=x+Cos(winkel)
y=y+Sin(winkel)
WritePixelFast(x,y,$FF006400)
 DebugLog x+","+y
If RectsOverlap(x,y,1,1,mast(mast_number,0),mast(mast_number,1)+52,1,1)  mast_number=mast_number+1
Until mast_number>mast_anzahl-1
For i=0 To mast_anzahl-2
If mast(i,1)<>mast(i+1,1)  Triangle(mast(i+1,0),mast(i+1,1)+52,mast(i,0),mast(i,1)+52,mast(i+1,0),mast(i,1)+52,$FF006400)
Next
UnlockBuffer ImageBuffer(berg)
Color 0,100,0
Rect 0,450,50,50
For i=0 To mast_anzahl-1
Rect mast(i,0),mast(i,1)+52,1090-mast(i,0),480-mast(i,1),1
Next
SetBuffer BackBuffer()
.menu
SetFont menu_font
Repeat
WaitTimer(timer)
Cls
TileBlock hintergrund,0,0
DrawImage berg,0,0
spam_time=spam_time+1
If spam_time>level(level_nummer,1) And gondel_anzahl<level(level_nummer,0) 
gondel.gondel=New gondel
gondel\x=50
gondel\y=390
gondel_anzahl=gondel_anzahl+1
spam_time=0
EndIf
DrawGondel(1,1)
DrawMast()
DrawGondel(0,1)
For i=0 To station_anzahl-1
DrawImage station_img,station(i,0),station(i,1)
Next
Color 255,200,0
string_width=StringWidth("Spiel starten")
string_height=StringHeight("string")
If RectsOverlap(mx,my,1,1,320+scroll_x-string_width/2,50,string_width,string_height) 
Color 255,100,0
If mh=1  Exit
EndIf
Text 320+scroll_x-string_width/2,50,"Spiel starten"
Color 255,200,0
string_width=StringWidth("Beenden")
If RectsOverlap(mx,my,1,1,320+scroll_x-string_width/2,150,string_width,string_height) 
Color 255,100,0
If mh=1  End
EndIf
Text 320+scroll_x-string_width/2,150,"Beenden"
If scroll_richtung=0  scroll_x=scroll_x-1
If scroll_richtung=1  scroll_x=scroll_x+1
If scroll_x<0  scroll_x=0 : scroll_richtung=Not scroll_richtung
If scroll_x>450  scroll_x=450 : scroll_richtung=Not scroll_richtung
Origin -scroll_x,0
Mouse()
If KeyHit(1)  End
Flip
Forever
level_nummer=0
.startgame
FlushMouse()
FlushKeys()
InitGondelbahn()
Global start_zeit=MilliSecs()
Repeat
WaitTimer(timer)
Cls
TileBlock hintergrund,0,0
DrawImage berg,0,0
spam_time=spam_time+1
If spam_time>level(level_nummer,1) And gondel_anzahl<level(level_nummer,0) 
gondel.gondel=New gondel
gondel\x=50
gondel\y=390
gondel_anzahl=gondel_anzahl+1
spam_time=0
EndIf
DrawGondel(1)
DrawMast()
DrawGondel(0)
For i=0 To station_anzahl-1
DrawImage station_img,station(i,0),station(i,1)
Next
status=Status()
If mx-scroll_x<50  scroll_x=scroll_x-5
If mx-scroll_x>590  scroll_x=scroll_x+5
If scroll_x<0  scroll_x=0 
If scroll_x>450  scroll_x=450
Origin -scroll_x,0
Mouse(1)
If KeyHit(1)  End
Flip 0
Until status=1
FlushMouse()
FlushKeys()
SetFont menu_font
Repeat
WaitTimer(timer)
Cls
TileBlock hintergrund,0,0
DrawImage berg,0,0
spam_time=spam_time+1
If spam_time>level(level_nummer,1) And gondel_anzahl<level(level_nummer,0) 
gondel.gondel=New gondel
gondel\x=50
gondel\y=390
gondel_anzahl=gondel_anzahl+1
spam_time=0
EndIf
DrawGondel(1,1)
DrawMast()
DrawGondel(0,1)
For i=0 To station_anzahl-1
DrawImage station_img,station(i,0),station(i,1)
Next
Color 255,200,0
string_width=StringWidth("Punkte: "+punkte)
string_height=StringHeight("string")
Text 320+scroll_x-string_width/2,50,"Punkte: "+punkte
string_value$="Nchstes Level"
If level_nummer=5  string_value="Neustart"
string_width=StringWidth(string_value)
If RectsOverlap(mx,my,1,1,320+scroll_x-string_width/2,150,string_width,string_height) 
Color 255,100,0
If mh=1 
level_nummer=level_nummer+1
If level_nummer>5 
level_nummer=0
EndIf
punkte=0
Goto startgame
EndIf
EndIf
Text 320+scroll_x-string_width/2,150,string_value
Color 255,200,0
string_width=StringWidth("Zurck zum Men")
If RectsOverlap(mx,my,1,1,320+scroll_x-string_width/2,250,string_width,string_height) 
Color 255,100,0
If mh=1  Goto menu
EndIf
Text 320+scroll_x-string_width/2,250,"Zurck zum Men"
If scroll_richtung=0  scroll_x=scroll_x-1
If scroll_richtung=1  scroll_x=scroll_x+1
If scroll_x<0  scroll_x=0 : scroll_richtung=Not scroll_richtung
If scroll_x>450  scroll_x=450 : scroll_richtung=Not scroll_richtung
Origin -scroll_x,0
Mouse()
If KeyHit(1)  End
Flip
Forever
Function InitGondelbahn()
SetFont status_font
For gondel.gondel=Each gondel
Delete gondel.gondel
Next
gondel_anzahl=0
scroll_x=0
End Function
Function DrawMast()
Color 50,50,50
For i=1 To mast_anzahl-1
Line mast(i,0),mast(i,1)+1,mast(i-1,0),mast(i-1,1)+1
Next
For i=0 To mast_anzahl-1
;Mast-Koordinaten berechnen
winkel1=-7
winkel2=7
If i=0 
winkel2=ATan2(mast(i+1,1)-mast(i,1),mast(i+1,0)-mast(i,0))+7
winkel=winkel2/2
ElseIf i=mast_anzahl-1 
winkel1=ATan2(mast(i,1)-mast(i-1,1),mast(i,0)-mast(i-1,0))-7
winkel=winkel1/2
Else
winkel1=ATan2(mast(i,1)-mast(i-1,1),mast(i,0)-mast(i-1,0))-7
winkel2=ATan2(mast(i+1,1)-mast(i,1),mast(i+1,0)-mast(i,0))+7
winkel=(winkel1+winkel2)/2
EndIf

;Mast zeichnen
Color 150,150,150
Oval mast(i,0)-Cos(winkel1)*9,mast(i,1)-Sin(winkel1)*6,6,6,1
Oval mast(i,0)-3,mast(i,1),6,6,1
Oval mast(i,0)+Cos(winkel2)*3,mast(i,1)+Sin(winkel2)*6,6,6,1
Color 100,100,100
Line mast(i,0),mast(i,1)+2,mast(i,0),mast(i,1)+52
Line mast(i,0)-1,mast(i,1)+2,mast(i,0)-1,mast(i,1)+52
Color 255,0,0
Oval mast(i,0)-Cos(winkel1)*9+1,mast(i,1)-Sin(winkel1)*6+1,4,4,1
Oval mast(i,0)-2,mast(i,1)+1,4,4,1
Oval mast(i,0)+Cos(winkel2)*3+1,mast(i,1)+Sin(winkel2)*6+1,4,4,1
Next
End Function
Function DrawGondel(richtung,menu=0)
For gondel.gondel=Each gondel
If gondel\richtung<>richtung  Goto gondel_end

;Gondel bewegen
winkel=ATan2(mast(gondel\mast,1)-gondel\y,mast(gondel\mast,0)-gondel\x)
gondel\x=gondel\x+Cos(winkel)*level(level_nummer,2)
gondel\y=gondel\y+Sin(winkel)*level(level_nummer,2)

If gondel\fall=1 
gondel\temp_y=gondel\temp_y+5
temp_x#=gondel\x
temp_y#=gondel\y
gondel\x=gondel\temp_x
gondel\y=gondel\temp_y
Else
gondel\temp_x=gondel\x
gondel\temp_y=gondel\y
EndIf

If gondel\del=1  Goto gondel_del


;Gondel zeichnen
Color 200,200,200
If gondel\fall=0 
Line gondel\x-Cos(winkel)*5,gondel\y-Sin(winkel)*5-1,gondel\x+Cos(winkel)*5,gondel\y+Sin(winkel)*5-1
Line gondel\x-Cos(winkel)*7,gondel\y-Sin(winkel)*7-.5,gondel\x+Cos(winkel)*7,gondel\y+Sin(winkel)*7-.5
Line gondel\x-Cos(winkel)*9,gondel\y-Sin(winkel)*9,gondel\x+Cos(winkel)*9,gondel\y+Sin(winkel)*9
Line gondel\x-Cos(winkel)*10,gondel\y-Sin(winkel)*10+.5,gondel\x+Cos(winkel)*10,gondel\y+Sin(winkel)*10+.5
EndIf
Line gondel\x,gondel\y,gondel\x,gondel\y+20
DrawImage gondel_img,gondel\x-15,gondel\y+20

Color 0,0,100
If gondel\kaputt=0 
Rect gondel\x-15,gondel\y+32,5,5,1
Rect gondel\x+11,gondel\y+32,5,5,1
ElseIf gondel\kaputt=1
Rect gondel\x-15,gondel\y+32,5,5,1
ElseIf gondel\kaputt=-1
Rect gondel\x+11,gondel\y+32,5,5,1
EndIf

Color 255,100,0
Oval gondel\x-2,gondel\y+33,5,5
If gondel\richtung=1 
Oval gondel\x-9,gondel\y+33,5,5
Oval gondel\x+5,gondel\y+33,5,5
EndIf


;Gondel kontrolieren
If menu=0 
If gondel\y>480 
gondel\del=1
gondel\fall=0
gondel\x=temp_x
gondel\y=temp_y
EndIf
If gondel\fall=1 
gondel\x=temp_x
gondel\y=temp_y
EndIf

For i=0 To station_anzahl-1
If RectsOverlap(mx,my,1,1,station(i,0),station(i,1),120,105)  Goto gondel_del
Next
If mh 
If RectsOverlap(mx,my,1,1,gondel\x-level(level_nummer,2),gondel\y,level(level_nummer,2)*2+1,25) And gondel\fall=0 
gondel\fall=1
punkte=punkte+50
If gondel\kaputt<>0 
If gondel\kaputt=2 
punkte=punkte-10
Else
punkte=punkte-5
EndIf
EndIf
EndIf

If RectsOverlap(mx,my,1,1,gondel\x-15,gondel\y+20,31,20) And gondel\kaputt<>2 And gondel\fall=0 
If mx>gondel\x 
If gondel\kaputt<>1 
If gondel\kaputt=0 
gondel\kaputt=1
Else
gondel\kaputt=2
EndIf
punkte=punkte+5
EndIf
Else
If gondel\kaputt<>-1 
If gondel\kaputt=0 
gondel\kaputt=-1
Else
gondel\kaputt=2
EndIf
punkte=punkte+5
EndIf
EndIf
Goto gondel_end
EndIf
EndIf
EndIf

.gondel_del

If RectsOverlap(gondel\x-2,gondel\y,4,3,mast(gondel\mast,0)-2,mast(gondel\mast,1),4,3) 
gondel\mast=gondel\mast+1-2*gondel\richtung
If gondel\mast<0 Or gondel\mast>mast_anzahl-1  
gondel\richtung=Not gondel\richtung
gondel\mast=gondel\mast+1-2*gondel\richtung
gondel\del=0
If gondel\kaputt<>0 
gondel\del=1
EndIf
gondel\kaputt=0
EndIf
EndIf

.gondel_end
Next
End Function
Function Status()
Color 255,255,255
Rect 0+scroll_x,0,160,80,0
Text 10+scroll_x,10,"FPS:"
If MilliSecs()-fps_millisecs>1000 
fps_millisecs=fps_millisecs+1000
fps=temp_fps
temp_fps=0
EndIf
temp_fps=temp_fps+1
Text 150+scroll_x-StringWidth(fps),10,fps
Color 255,255,255
Text 10+scroll_x,25,"Level"
Text 150+scroll_x-StringWidth(level_nummer+1),25,level_nummer+1
zeit=level(level_nummer,3)-(MilliSecs()-start_zeit)/1000
zeit_ausgabe$=zeit/60+" min "+zeit Mod 60+" sek"
If zeit<11  Color 255,0,0
Text 10+scroll_x,40,"Zeit:"
Text 150+scroll_x-StringWidth(zeit_ausgabe),40,zeit_ausgabe
Color 255,255,255
If punkte>999999 
Color 0,255,0
ElseIf punkte>999 
Color 100,200,255
EndIf
Text 10+scroll_x,55,"Punkte:"
Text 150+scroll_x-StringWidth(punkte),55,punkte
If zeit<=0  Return 1
End Function
Function Mouse(var=0)
temp_mx=temp_mx+MouseXSpeed()
mx=temp_mx+scroll_x
my=my+MouseYSpeed()
mh=MouseHit(1)
If var=1 
If mh=1  punkte=punkte-1
my=my+1
EndIf
If temp_mx<0  temp_mx=0
If temp_mx>640  temp_mx=640
If my<0  my=0
If my>480  my=480
Color 255,255,255
Oval mx-5,my-5,11,11,0
Line mx-7,my,mx+7,my
Line mx,my-7,mx,my+7
MoveMouse(320,240)
End Function
Function Triangle(x0,y0,x1,y1,x2,y2,rgb)
ey=y1
buffer=GraphicsBuffer()
dx1=x1-x0
dy1=y1-y0
df1=dx1/dy1
dm1=Abs(dx1 Mod dy1)
If x0>x1
xs1=-1
Else
xs1=1
EndIf
dx2=x2-x0
dy2=y2-y0
df2=dx2/dy2
dm2=Abs(dx2 Mod dy2)
If x0>x2
xs2=-1
Else
xs2=1
EndIf
xp1=x0
mc1=dm1
xp2=x0
mc2=dm2
For yp=y0 To ey
xc1=xp1
xc2=xp2
For xp=xc1 To xc2
WritePixelFast xp,yp,rgb,buffer
Next
xp1=xp1+df1
mc1=mc1+dm1
If mc1>=dy1
mc1=mc1-dy1
xp1=xp1+xs1
EndIf
xp2=xp2+df2
mc2=mc2+dm2
If mc2>=dy2
mc2=mc2-dy2
xp2=xp2+xs2
End If
Next
End Function